(in-package :cl-user)

;;; Load asdf, if necessary; set up asdf:*central-registry* 
;;; and load everything necessary to run cell-gtk. 

#+mswindows
(warn "MSWindows users: If you want to use libcellsgtk.so see gtk-ffi/Makefile.")

#-mswindows
(let ((libpath (cond ((directory "/usr/lib/libgtk*") "/usr/lib/")
                     ((directory "/opt/gnome/lib/libgtk*") "/opt/gnome/lib/"))))
  (if libpath
    (if (probe-file (concatenate 'string libpath "libcellsgtk.so"))
      (pushnew :libcellsgtk *features*)
      (warn "libcellsgtk.so not found. Just a few capabilities will be unavailable."))
    (error "Cannot find a path containing libgtk")))

#-asdf(load (compile-file "asdf"))

(setf (logical-pathname-translations "cells-gtk")
	`(("root;*.*.*"
	   ,(make-pathname
	     :name :wild :type :wild :version :wild
	     :defaults *load-truename*))
	  ("**;*.*.*"
	   ,(merge-pathnames
	     (make-pathname
	      :directory '(:relative :wild-inferiors)
	      :name :wild :type :wild :version :wild
	      :defaults *load-truename*)
	     *load-truename*))))

(let ((asdf:*central-registry* 
        (list #P"cells-gtk:"
              #P"cells-gtk:utils-kt;"
              #P"cells-gtk:cells;"
              #P"cells-gtk:hello-c;"
              #P"cells-gtk:root;gtk-ffi;"
              #P"cells-gtk:root;cells-gtk;"
              #P"cells-gtk:root;cells-gtk;test-gtk;")))
  (asdf:oos 'asdf:load-op :utils-kt)
  (asdf:oos 'asdf:load-op :cells)
  (asdf:oos 'asdf:load-op :hello-c)
  (asdf:oos 'asdf:load-op :gtk-ffi)
  (asdf:oos 'asdf:load-op :cells-gtk)
  (asdf:oos 'asdf:load-op :test-gtk))

(format t "~3% Done! Now try (test-gtk::gtk-demo)")






