#|

 Gtk ffi

 Copyright (c) 2004 by Vasilis Margioulas <vasilism@sch.gr>

 You have the right to distribute and use this software as governed by 
 the terms of the Lisp Lesser GNU Public License (LLGPL):

    (http://opensource.franz.com/preamble.html)
 
 This program is distributed in the hope that it will be useful,
 but WITHOUT ANY WARRANTY; without even the implied warranty of
 MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 Lisp Lesser GNU Public License for more details.
 
|#

(in-package :gtk-ffi)

(def-gtk-lib-functions :gtk
  ;;list-store  
  (gtk-list-store-newv ((n-columns int)
			(col-types c-pointer))
    c-pointer)
  (gtk-list-store-set-valist ((store c-pointer)
			      (iter c-pointer)
			      (data c-pointer)))
  (gtk-list-store-set-value ((store c-pointer)
			     (iter c-pointer)
			     (column int)
			     (value c-pointer)))
  (gtk-list-store-append ((list-store c-pointer)
			  (iter c-pointer)))
  (gtk-list-store-clear ((list-store c-pointer)))

  ;;tree-store
  (gtk-tree-store-newv ((n-columns int)
			(col-types (c-array-ptr int)))
    c-pointer)
  (gtk-tree-store-set-valist ((store c-pointer)
			      (iter c-pointer)
			      (data c-pointer)))
  (gtk-tree-store-set-value ((store c-pointer)
			     (iter c-pointer)
			     (column int)
			     (value c-pointer)))
  (gtk-tree-store-append ((list-store c-pointer)
			  (iter c-pointer)
			  (parent c-pointer)))
  (gtk-tree-store-clear ((list-store c-pointer)))

  ;;tree-view
  (gtk-tree-view-new ()
    c-pointer)
  (gtk-tree-view-set-model ((tree-view c-pointer)
			    (model c-pointer)))
  (gtk-tree-view-insert-column ((tree-view c-pointer)
				(column c-pointer)
				(pos int))
    int)
  (gtk-tree-view-get-selection ((tree-view c-pointer))
     c-pointer)
  (gtk-tree-view-get-path-at-pos ((tree-view c-pointer)
                                  (x int)
                                  (y int)
                                  (path c-pointer)
                                  (column c-pointer)
                                  (cell-x c-pointer)
                                  (cell-y c-pointer))
     boolean)
  (gtk-tree-view-widget-to-tree-coords ((tree-view c-pointer)
                                        (wx int)
                                        (wy int)
                                        (tx c-pointer)
                                        (ty c-pointer)))
  (gtk-tree-view-tree-to-widget-coords ((tree-view c-pointer)
                                        (wx int)
                                        (wy int)
                                        (tx c-pointer)
                                        (ty c-pointer)))

  ;;tree-model
  (gtk-tree-model-get ((tree-model c-pointer)
		       (iter c-pointer)
		       (column int)
		       (data c-pointer)
		       (eof int)))
  (gtk-tree-model-get-iter-from-string ((tree-model c-pointer)
					(iter c-pointer)
					(path c-string))
    boolean)				       

  ;;tree-path
  (gtk-tree-path-new-from-string ((path c-string))
    c-pointer)
  (gtk-tree-path-to-string ((path c-pointer))
    c-string)
  (gtk-tree-path-free ((path c-pointer)))

  ;;tree-selection
   (gtk-tree-selection-set-mode ((sel c-pointer)
				 (mode int)))
   (gtk-tree-selection-get-mode ((sel c-pointer))
     int)
   (gtk-tree-selection-select-path ((sel c-pointer)
				    (path c-pointer)))
   (gtk-tree-selection-get-selected ((sel c-pointer)
				     (model c-pointer)
				     (iter c-pointer))
     boolean)
   (gtk-tree-selection-selected-foreach ((sel c-pointer)
					 (callback-f #.(callback-function ((model c-pointer)
									   (path c-pointer)
									   (iter c-pointer)
									   (data c-pointer))))
					 (data c-pointer)))
  ;;tree-view-column
  (gtk-tree-view-column-new ()
    c-pointer)
  (gtk-tree-view-column-pack-start ((tree-column c-pointer)
				    (renderer c-pointer)
				    (expand boolean))
    nil nil nil)
  (gtk-tree-view-column-add-attribute ((tree-column c-pointer)
				       (renderer c-pointer)
				       (attribute c-string)
				       (column int)))
  (gtk-tree-view-column-set-spacing ((tree-column c-pointer)
				     (spacing int)))
  (gtk-tree-view-column-set-visible ((tree-column c-pointer)
				     (spacing boolean))
    nil nil nil)
  (gtk-tree-view-column-set-reorderable ((tree-column c-pointer)
				       (resizable boolean)))
  (gtk-tree-view-column-set-sort-column-id ((tree-column c-pointer)
					    (col-id int)))
  (gtk-tree-view-column-set-sort-indicator ((tree-column c-pointer)
					    (resizable boolean)))
  (gtk-tree-view-column-set-resizable ((tree-column c-pointer)
				       (resizable boolean)))
  (gtk-tree-view-column-set-fixed-width ((tree-column c-pointer)
					 (fixed-width int)))
  (gtk-tree-view-column-set-min-width ((tree-column c-pointer)
				       (min-width int)))
  (gtk-tree-view-column-set-max-width ((tree-column c-pointer)
					 (max-width int)))
  (gtk-tree-view-column-set-title ((tree-column c-pointer)
				   (title c-string)))
  (gtk-tree-view-column-set-expand ((tree-column c-pointer)
				    (expand boolean)))
  (gtk-tree-view-column-set-clickable ((tree-column c-pointer)
				       (clickable boolean)))
  (gtk-tree-view-column-set-cell-data-func ((tree-column c-pointer)
					    (cell-renderer c-pointer)
					    (func #.(callback-function ((tree-column c-pointer)
									(cell-renderer c-pointer)
									(tree-model c-pointer)
									(iter c-pointer)
									(data c-pointer))))
					    (data c-pointer)
					    (destroy c-pointer)))
  ;;cell-renderers
  (gtk-cell-renderer-text-new ()
    c-pointer)
  (gtk-cell-renderer-toggle-new ()
    c-pointer)
  (gtk-cell-renderer-pixbuf-new ()
    c-pointer)
  (gtk-cell-renderer-set-fixed-size ((cell c-pointer)
                                 (width int)
                                 (height int))))
